#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <limits.h>
#include <math.h>


using namespace std;


int n, a, b, k, K;
vector<int> w;
const int& negINF = INT_MIN;
int ans = negINF;


bool pointInAB(int p) {
	int A = a - p;
	int B = b - p;
	int N = B / K;
	return B >= 0 && A <= N*K;
}


bool pointInLR(int p, int R) {
	int N = p / K;
	return p >= 0 && p <= R + N*K;
}


int check(int d, int value) {
	int l = d*k + 1;
	int r = (d+1) * k;
	return (pointInAB(l) || pointInAB(r) || pointInLR(a-l, r-l) || pointInLR(b-l, r-l)) ? value : negINF;
}


int main() {
	freopen("wheel.in", "r", stdin);
	freopen("wheel.out", "w", stdout);
	cin >> n; w.resize(n);
	for (int i = 0; i < w.size(); i++) {
		cin >> w[i];
	}
	cin >> a >> b >> k;
	K = n*k;
	
	for (int i = 0; i < w.size(); i++) {
		ans = max(ans, max(check(i, w[i]), check(n-i, w[i])));
	}
	cout << ans;
	return 0;
}
